// Code generated by protoc-gen-go. DO NOT EDIT.
// source: mesh/v1alpha1/metrics.proto

package v1alpha1

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	_struct "github.com/golang/protobuf/ptypes/struct"
	wrappers "github.com/golang/protobuf/ptypes/wrappers"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// Metrics defines configuration for metrics that should be collected and
// exposed by dataplanes.
type Metrics struct {
	// Name of the enabled backend
	EnabledBackend string `protobuf:"bytes,1,opt,name=enabledBackend,proto3" json:"enabledBackend,omitempty"`
	// List of available Metrics backends
	Backends             []*MetricsBackend `protobuf:"bytes,2,rep,name=backends,proto3" json:"backends,omitempty"`
	XXX_NoUnkeyedLiteral struct{}          `json:"-"`
	XXX_unrecognized     []byte            `json:"-"`
	XXX_sizecache        int32             `json:"-"`
}

func (m *Metrics) Reset()         { *m = Metrics{} }
func (m *Metrics) String() string { return proto.CompactTextString(m) }
func (*Metrics) ProtoMessage()    {}
func (*Metrics) Descriptor() ([]byte, []int) {
	return fileDescriptor_7dd8c7f420ce268c, []int{0}
}

func (m *Metrics) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Metrics.Unmarshal(m, b)
}
func (m *Metrics) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Metrics.Marshal(b, m, deterministic)
}
func (m *Metrics) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Metrics.Merge(m, src)
}
func (m *Metrics) XXX_Size() int {
	return xxx_messageInfo_Metrics.Size(m)
}
func (m *Metrics) XXX_DiscardUnknown() {
	xxx_messageInfo_Metrics.DiscardUnknown(m)
}

var xxx_messageInfo_Metrics proto.InternalMessageInfo

func (m *Metrics) GetEnabledBackend() string {
	if m != nil {
		return m.EnabledBackend
	}
	return ""
}

func (m *Metrics) GetBackends() []*MetricsBackend {
	if m != nil {
		return m.Backends
	}
	return nil
}

// MetricsBackend defines metric backends
type MetricsBackend struct {
	// Name of the backend, can be then used in Mesh.metrics.enabledBackend
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// Type of the backend (Kuma ships with 'prometheus')
	Type string `protobuf:"bytes,2,opt,name=type,proto3" json:"type,omitempty"`
	// Configuration of the backend
	Conf                 *_struct.Struct `protobuf:"bytes,3,opt,name=conf,proto3" json:"conf,omitempty"`
	XXX_NoUnkeyedLiteral struct{}        `json:"-"`
	XXX_unrecognized     []byte          `json:"-"`
	XXX_sizecache        int32           `json:"-"`
}

func (m *MetricsBackend) Reset()         { *m = MetricsBackend{} }
func (m *MetricsBackend) String() string { return proto.CompactTextString(m) }
func (*MetricsBackend) ProtoMessage()    {}
func (*MetricsBackend) Descriptor() ([]byte, []int) {
	return fileDescriptor_7dd8c7f420ce268c, []int{1}
}

func (m *MetricsBackend) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_MetricsBackend.Unmarshal(m, b)
}
func (m *MetricsBackend) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_MetricsBackend.Marshal(b, m, deterministic)
}
func (m *MetricsBackend) XXX_Merge(src proto.Message) {
	xxx_messageInfo_MetricsBackend.Merge(m, src)
}
func (m *MetricsBackend) XXX_Size() int {
	return xxx_messageInfo_MetricsBackend.Size(m)
}
func (m *MetricsBackend) XXX_DiscardUnknown() {
	xxx_messageInfo_MetricsBackend.DiscardUnknown(m)
}

var xxx_messageInfo_MetricsBackend proto.InternalMessageInfo

func (m *MetricsBackend) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *MetricsBackend) GetType() string {
	if m != nil {
		return m.Type
	}
	return ""
}

func (m *MetricsBackend) GetConf() *_struct.Struct {
	if m != nil {
		return m.Conf
	}
	return nil
}

// PrometheusMetricsBackendConfig defines configuration of Prometheus backend
type PrometheusMetricsBackendConfig struct {
	// Port on which a dataplane should expose HTTP endpoint with Prometheus
	// metrics.
	Port uint32 `protobuf:"varint,1,opt,name=port,proto3" json:"port,omitempty"`
	// Path on which a dataplane should expose HTTP endpoint with Prometheus
	// metrics.
	Path string `protobuf:"bytes,2,opt,name=path,proto3" json:"path,omitempty"`
	// Tags associated with an application this dataplane is deployed next to,
	// e.g. service=web, version=1.0.
	// `service` tag is mandatory.
	Tags map[string]string `protobuf:"bytes,3,rep,name=tags,proto3" json:"tags,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// If true then endpoints for scraping metrics won't require mTLS even if mTLS
	// is enabled in Mesh. If nil, then it is treated as set to true.
	//
	// todo(jakubdyszkiewicz) In next major version of Kuma, change BoolValue to
	// bool, so the default is false
	SkipMTLS             *wrappers.BoolValue `protobuf:"bytes,4,opt,name=skipMTLS,proto3" json:"skipMTLS,omitempty"`
	XXX_NoUnkeyedLiteral struct{}            `json:"-"`
	XXX_unrecognized     []byte              `json:"-"`
	XXX_sizecache        int32               `json:"-"`
}

func (m *PrometheusMetricsBackendConfig) Reset()         { *m = PrometheusMetricsBackendConfig{} }
func (m *PrometheusMetricsBackendConfig) String() string { return proto.CompactTextString(m) }
func (*PrometheusMetricsBackendConfig) ProtoMessage()    {}
func (*PrometheusMetricsBackendConfig) Descriptor() ([]byte, []int) {
	return fileDescriptor_7dd8c7f420ce268c, []int{2}
}

func (m *PrometheusMetricsBackendConfig) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_PrometheusMetricsBackendConfig.Unmarshal(m, b)
}
func (m *PrometheusMetricsBackendConfig) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_PrometheusMetricsBackendConfig.Marshal(b, m, deterministic)
}
func (m *PrometheusMetricsBackendConfig) XXX_Merge(src proto.Message) {
	xxx_messageInfo_PrometheusMetricsBackendConfig.Merge(m, src)
}
func (m *PrometheusMetricsBackendConfig) XXX_Size() int {
	return xxx_messageInfo_PrometheusMetricsBackendConfig.Size(m)
}
func (m *PrometheusMetricsBackendConfig) XXX_DiscardUnknown() {
	xxx_messageInfo_PrometheusMetricsBackendConfig.DiscardUnknown(m)
}

var xxx_messageInfo_PrometheusMetricsBackendConfig proto.InternalMessageInfo

func (m *PrometheusMetricsBackendConfig) GetPort() uint32 {
	if m != nil {
		return m.Port
	}
	return 0
}

func (m *PrometheusMetricsBackendConfig) GetPath() string {
	if m != nil {
		return m.Path
	}
	return ""
}

func (m *PrometheusMetricsBackendConfig) GetTags() map[string]string {
	if m != nil {
		return m.Tags
	}
	return nil
}

func (m *PrometheusMetricsBackendConfig) GetSkipMTLS() *wrappers.BoolValue {
	if m != nil {
		return m.SkipMTLS
	}
	return nil
}

func init() {
	proto.RegisterType((*Metrics)(nil), "kuma.mesh.v1alpha1.Metrics")
	proto.RegisterType((*MetricsBackend)(nil), "kuma.mesh.v1alpha1.MetricsBackend")
	proto.RegisterType((*PrometheusMetricsBackendConfig)(nil), "kuma.mesh.v1alpha1.PrometheusMetricsBackendConfig")
	proto.RegisterMapType((map[string]string)(nil), "kuma.mesh.v1alpha1.PrometheusMetricsBackendConfig.TagsEntry")
}

func init() { proto.RegisterFile("mesh/v1alpha1/metrics.proto", fileDescriptor_7dd8c7f420ce268c) }

var fileDescriptor_7dd8c7f420ce268c = []byte{
	// 355 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x7c, 0x90, 0x4f, 0x4b, 0xeb, 0x40,
	0x14, 0xc5, 0xc9, 0x9f, 0xf7, 0x5e, 0x3b, 0xe5, 0x95, 0xc7, 0xf0, 0xc0, 0x10, 0xa5, 0x94, 0x2c,
	0xa4, 0x20, 0x4c, 0x68, 0x05, 0x15, 0x11, 0x17, 0x15, 0x77, 0x16, 0x4a, 0x5a, 0x5c, 0xb8, 0x9b,
	0xa4, 0xb7, 0x49, 0xc9, 0x9f, 0x89, 0x33, 0x93, 0x4a, 0x3f, 0x83, 0x5f, 0x5a, 0x66, 0x92, 0x14,
	0xda, 0x8a, 0xbb, 0x93, 0x3b, 0xe7, 0x9e, 0xdf, 0x3d, 0x41, 0xe7, 0x39, 0x88, 0xc4, 0xdf, 0x8e,
	0x69, 0x56, 0x26, 0x74, 0xec, 0xe7, 0x20, 0xf9, 0x26, 0x12, 0xa4, 0xe4, 0x4c, 0x32, 0x8c, 0xd3,
	0x2a, 0xa7, 0x44, 0x39, 0x48, 0xeb, 0x70, 0x2f, 0x62, 0xc6, 0xe2, 0x0c, 0x7c, 0xed, 0x08, 0xab,
	0xb5, 0x2f, 0x24, 0xaf, 0x22, 0x59, 0x6f, 0xb8, 0x83, 0xe3, 0xd7, 0x0f, 0x4e, 0xcb, 0x12, 0x78,
	0x93, 0xe8, 0xbd, 0xa3, 0x3f, 0xb3, 0x1a, 0x81, 0x2f, 0x51, 0x1f, 0x0a, 0x1a, 0x66, 0xb0, 0x9a,
	0xd2, 0x28, 0x85, 0x62, 0xe5, 0x18, 0x43, 0x63, 0xd4, 0x0d, 0x8e, 0xa6, 0xf8, 0x11, 0x75, 0xc2,
	0x5a, 0x0a, 0xc7, 0x1c, 0x5a, 0xa3, 0xde, 0xc4, 0x23, 0xa7, 0x77, 0x91, 0x26, 0xb6, 0xd9, 0x0a,
	0xf6, 0x3b, 0x1e, 0xa0, 0xfe, 0xe1, 0x1b, 0xc6, 0xc8, 0x2e, 0x68, 0x0e, 0x0d, 0x4f, 0x6b, 0x35,
	0x93, 0xbb, 0x12, 0x1c, 0xb3, 0x9e, 0x29, 0x8d, 0xaf, 0x90, 0x1d, 0xb1, 0x62, 0xed, 0x58, 0x43,
	0x63, 0xd4, 0x9b, 0x9c, 0x91, 0xba, 0x1b, 0x69, 0xbb, 0x91, 0x85, 0x6e, 0x1e, 0x68, 0x93, 0xf7,
	0x69, 0xa2, 0xc1, 0x9c, 0xb3, 0x1c, 0x64, 0x02, 0x95, 0x38, 0x24, 0x3e, 0xb1, 0x62, 0xbd, 0x89,
	0x15, 0xa3, 0x64, 0x5c, 0x6a, 0xee, 0xdf, 0x40, 0x6b, 0x3d, 0xa3, 0x32, 0x69, 0xb9, 0x4a, 0xe3,
	0x39, 0xb2, 0x25, 0x8d, 0x85, 0x63, 0xe9, 0xb6, 0x0f, 0xdf, 0xb5, 0xfd, 0x99, 0x44, 0x96, 0x34,
	0x16, 0xcf, 0x85, 0xe4, 0xbb, 0x40, 0x27, 0xe1, 0x1b, 0xd4, 0x11, 0xe9, 0xa6, 0x9c, 0x2d, 0x5f,
	0x16, 0x8e, 0xad, 0xdb, 0xb8, 0x27, 0x6d, 0xa6, 0x8c, 0x65, 0xaf, 0x34, 0xab, 0x20, 0xd8, 0x7b,
	0xdd, 0x5b, 0xd4, 0xdd, 0x47, 0xe1, 0x7f, 0xc8, 0x4a, 0x61, 0xd7, 0xfc, 0x35, 0x25, 0xf1, 0x7f,
	0xf4, 0x6b, 0xab, 0x36, 0x9a, 0xeb, 0xeb, 0x8f, 0x7b, 0xf3, 0xce, 0x98, 0xa2, 0xb7, 0x4e, 0x7b,
	0x6b, 0xf8, 0x5b, 0x23, 0xae, 0xbf, 0x02, 0x00, 0x00, 0xff, 0xff, 0x05, 0x61, 0xef, 0x74, 0x6b,
	0x02, 0x00, 0x00,
}
